Index: trunk/source/processes/hadronic/models/coherent_elastic/History
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/History	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/History	(revision 1337)
@@ -14,4 +14,9 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
+
+15 June 2010 - V.Ivanchenko (hadr-cohe-V09-03-02)
+------------------------------------------------------
+- G4UHadronElasticProcess - fixed CHIPS warning for Cu, due to wrong
+  isotope sected (#bug report of ALICE)
 
 26 January 2010 - M.Kosov (hadr-cohe-V09-03-01)
Index: trunk/source/processes/hadronic/models/coherent_elastic/include/G4CHIPSElastic.hh
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/include/G4CHIPSElastic.hh	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/include/G4CHIPSElastic.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4CHIPSElastic.hh,v 1.4 2010/01/13 15:42:06 mkossov Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 // Geant4 Header : G4CHIPSElastic
Index: trunk/source/processes/hadronic/models/coherent_elastic/include/G4ChargeExchange.hh
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/include/G4ChargeExchange.hh	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/include/G4ChargeExchange.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ChargeExchange.hh,v 1.6 2009/09/22 16:21:46 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/source/processes/hadronic/models/coherent_elastic/include/G4ChargeExchangeProcess.hh
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/include/G4ChargeExchangeProcess.hh	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/include/G4ChargeExchangeProcess.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ChargeExchangeProcess.hh,v 1.3 2008/11/20 12:35:19 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/source/processes/hadronic/models/coherent_elastic/include/G4DiffuseElastic.hh
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/include/G4DiffuseElastic.hh	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/include/G4DiffuseElastic.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4DiffuseElastic.hh,v 1.17 2009/09/22 16:21:46 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/source/processes/hadronic/models/coherent_elastic/include/G4ElasticHadrNucleusHE.hh
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/include/G4ElasticHadrNucleusHE.hh	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/include/G4ElasticHadrNucleusHE.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ElasticHadrNucleusHE.hh,v 1.47 2009/09/22 16:21:46 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 // G4ElasticHadrNucleusHe.hh
Index: trunk/source/processes/hadronic/models/coherent_elastic/include/G4HadronElastic.hh
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/include/G4HadronElastic.hh	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/include/G4HadronElastic.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HadronElastic.hh,v 1.32 2010/01/13 15:42:06 mkossov Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/source/processes/hadronic/models/coherent_elastic/include/G4NuclNuclDiffuseElastic.hh
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/include/G4NuclNuclDiffuseElastic.hh	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/include/G4NuclNuclDiffuseElastic.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NuclNuclDiffuseElastic.hh,v 1.8 2009/04/10 13:22:25 grichine Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/source/processes/hadronic/models/coherent_elastic/include/G4UHadronElasticProcess.hh
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/include/G4UHadronElasticProcess.hh	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/include/G4UHadronElasticProcess.hh	(revision 1337)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4UHadronElasticProcess.hh,v 1.11 2010/01/13 15:42:06 mkossov Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+// $Id: G4UHadronElasticProcess.hh,v 1.12 2010/06/15 15:24:34 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 // Geant4 Hadron Elastic Scattering Process -- header file
@@ -47,4 +47,5 @@
 #include "G4HadronicProcess.hh"
 #include "G4Nucleus.hh"
+#include "G4StableIsotopes.hh"
 
 class G4VQCrossSection;
@@ -81,4 +82,5 @@
 private:
 
+  G4StableIsotopes            theDefaultIsotopes;
   G4VQCrossSection*           pCManager;
   G4VQCrossSection*           nCManager;
Index: trunk/source/processes/hadronic/models/coherent_elastic/include/G4VHadronElastic.hh
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/include/G4VHadronElastic.hh	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/include/G4VHadronElastic.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VHadronElastic.hh,v 1.4 2009/09/23 14:37:44 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 // Geant4 Header : G4VHadronElastic
Index: trunk/source/processes/hadronic/models/coherent_elastic/include/G4WHadronElasticProcess.hh
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/include/G4WHadronElasticProcess.hh	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/include/G4WHadronElasticProcess.hh	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4WHadronElasticProcess.hh,v 1.2 2009/09/22 17:35:07 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 // Geant4 Hadron Elastic Scattering Process -- header file
Index: trunk/source/processes/hadronic/models/coherent_elastic/src/G4CHIPSElastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/src/G4CHIPSElastic.cc	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/src/G4CHIPSElastic.cc	(revision 1337)
@@ -25,5 +25,5 @@
 //
 // $Id: G4CHIPSElastic.cc,v 1.4 2010/01/13 15:42:06 mkossov Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //---------------------------------------------------------------------
Index: trunk/source/processes/hadronic/models/coherent_elastic/src/G4ChargeExchange.cc
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/src/G4ChargeExchange.cc	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/src/G4ChargeExchange.cc	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ChargeExchange.cc,v 1.16 2009/09/22 16:21:46 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/source/processes/hadronic/models/coherent_elastic/src/G4ChargeExchangeProcess.cc
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/src/G4ChargeExchangeProcess.cc	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/src/G4ChargeExchangeProcess.cc	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ChargeExchangeProcess.cc,v 1.15 2008/11/27 16:43:00 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/source/processes/hadronic/models/coherent_elastic/src/G4DiffuseElastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/src/G4DiffuseElastic.cc	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/src/G4DiffuseElastic.cc	(revision 1337)
@@ -25,5 +25,5 @@
 //
 // $Id: G4DiffuseElastic.cc,v 1.25 2009/09/22 16:21:46 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/source/processes/hadronic/models/coherent_elastic/src/G4ElasticHadrNucleusHE.cc
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/src/G4ElasticHadrNucleusHE.cc	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/src/G4ElasticHadrNucleusHE.cc	(revision 1337)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ElasticHadrNucleusHE.cc,v 1.81 2009/09/22 16:21:46 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/source/processes/hadronic/models/coherent_elastic/src/G4HadronElastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/src/G4HadronElastic.cc	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/src/G4HadronElastic.cc	(revision 1337)
@@ -25,5 +25,5 @@
 //
 // $Id: G4HadronElastic.cc,v 1.66 2010/01/13 15:42:06 mkossov Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/source/processes/hadronic/models/coherent_elastic/src/G4NuclNuclDiffuseElastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/src/G4NuclNuclDiffuseElastic.cc	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/src/G4NuclNuclDiffuseElastic.cc	(revision 1337)
@@ -25,5 +25,5 @@
 //
 // $Id: G4NuclNuclDiffuseElastic.cc,v 1.2 2009/04/10 13:22:25 grichine Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 //
Index: trunk/source/processes/hadronic/models/coherent_elastic/src/G4UHadronElasticProcess.cc
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/src/G4UHadronElasticProcess.cc	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/src/G4UHadronElasticProcess.cc	(revision 1337)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4UHadronElasticProcess.cc,v 1.41 2010/01/26 13:34:01 mkossov Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+// $Id: G4UHadronElasticProcess.cc,v 1.42 2010/06/15 15:24:34 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 // Geant4 Hadron Elastic Scattering Process -- header file
@@ -302,5 +302,28 @@
     }
     A = G4double((*isv)[j]->GetN());
-  } 
+  } else {
+
+    G4int nIso   = theDefaultIsotopes.GetNumberOfIsotopes(iz);
+    G4int idxIso = theDefaultIsotopes.GetFirstIsotope(iz);
+    A = theDefaultIsotopes.GetIsotopeNucleonCount(idxIso);
+
+    if(1 < nIso) {
+
+      G4double cross  = 0.0;
+
+      G4int i = 0;
+      for (; i<nIso; ++i) {
+        cross  += theDefaultIsotopes.GetAbundance(idxIso+i);
+        xsec[i] = cross;
+      }
+      cross *= G4UniformRand();
+      for (i = 0; i<nIso; ++i) {
+        if(cross <= xsec[i]) {
+          A = theDefaultIsotopes.GetIsotopeNucleonCount(idxIso+i);
+          break;
+        }
+      }
+    }
+  }
 
   G4HadronicInteraction* hadi = 
Index: trunk/source/processes/hadronic/models/coherent_elastic/src/G4VHadronElastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/src/G4VHadronElastic.cc	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/src/G4VHadronElastic.cc	(revision 1337)
@@ -25,5 +25,5 @@
 //
 // $Id: G4VHadronElastic.cc,v 1.4 2009/09/23 14:37:44 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 // Geant4 Header : G4VHadronElastic
Index: trunk/source/processes/hadronic/models/coherent_elastic/src/G4WHadronElasticProcess.cc
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/src/G4WHadronElasticProcess.cc	(revision 1315)
+++ trunk/source/processes/hadronic/models/coherent_elastic/src/G4WHadronElasticProcess.cc	(revision 1337)
@@ -25,5 +25,5 @@
 //
 // $Id: G4WHadronElasticProcess.cc,v 1.3 2010/01/13 15:42:06 mkossov Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-beta-01 $
 //
 // Geant4 Hadron Elastic Scattering Process 
